﻿local addonName, E = ...

local C = E:Module("WhisperLogs")
local db = {}

local backdrop = {
	bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
	edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
	edgeSize = 1,
}
local copy_w, copy_h = 500, 300

local mover = CreateFrame("Frame", "AleaUIChatHistoryWhisperMover", E.UIParent)
mover:SetSize(copy_w, 20)
mover:SetPoint("CENTER", 0, 20)
mover:EnableMouse(true)
mover:SetMovable(true)
mover:RegisterForDrag("LeftButton")
mover:SetScript("OnDragStart", mover.StartMoving)
mover:SetScript("OnDragStop", mover.StopMovingOrSizing)
mover:Hide()
mover:SetBackdrop(backdrop)
mover:SetBackdropColor(0.1,0.1,0.1,0.9)
mover:SetBackdropBorderColor(0 , 0 , 0 , 1)

mover.Owner = mover:CreateFontString()
mover.Owner:SetPoint('LEFT', mover, 'LEFT')
mover.Owner:SetFont(E.media.default_font, E.media.default_font_size, 'OUTLINE')

local copyframe = CreateFrame("Frame", "AleaUIChatHistoryWhisperFrame", E.UIParent)
copyframe:SetPoint("TOPRIGHT", mover, "BOTTOMRIGHT", 0, -3)
copyframe:SetSize(copy_w, copy_h)
copyframe:SetFrameLevel(10)

table.insert(UISpecialFrames, "AleaUIChatHistoryWhisperFrame")
table.insert(UISpecialFrames, "AleaUIChatHistoryWhisperMover")
--[==[
copyframe.Scroll = CreateFrame("ScrollFrame", "AleaUIChatLogsScrollFrame", copyframe, "UIPanelScrollFrameTemplate")
copyframe.Scroll:SetFrameLevel(copyframe:GetFrameLevel() - 1)
copyframe.Scroll:SetSize(copy_w, copy_h)
copyframe.Scroll:SetPoint("TOPRIGHT", copyframe, "TOPRIGHT", 0, 0)

copyframe.editBox = CreateFrame("EditBox", nil, copyframe)
copyframe.editBox:SetPoint('TOPLEFT', copyframe.Scroll, "TOPLEFT", 11, 1)
copyframe.editBox:SetFontObject(GameFontWhite)
copyframe.editBox:SetHyperlinksEnabled(true)
copyframe.editBox:SetScript('OnHyperlinkClick', function(self, link, text, button)
	SetItemRef(link, text, button, self);
end)
copyframe.editBox:SetFrameLevel(E.UIParent:GetFrameLevel())

copyframe.Scroll:SetScrollChild(copyframe.editBox)
copyframe.Scroll:SetHorizontalScroll(-5)
copyframe.Scroll:SetVerticalScroll(0)
copyframe.Scroll:EnableMouse(true)

copyframe.editBox:SetSize(copy_w, copy_h)


copyframe.editBox:SetFont("Fonts\\ARIALN.TTF", 12)
--copyframe.editBox:SetFrameLevel(copyframe.Scroll:GetFrameLevel() + 1)
copyframe.editBox:SetAutoFocus(false)
copyframe.editBox:SetMultiLine(true)
copyframe.editBox:SetScript("OnEscapePressed", function(self)
	self:ClearFocus()
end)
]==]

local function CreateCoreButton(parent)
	local f = CreateFrame("Frame", nil, parent)
	f:SetPoint('CENTER', parent, 'CENTER', 0, 0)
	f:SetSize(500, 300)
	f:SetFrameLevel(parent:GetFrameLevel() + 3)
	f.Scroll = CreateFrame("ScrollFrame", 'AleaUIChatLogsScrollFrame', f, "UIPanelScrollFrameTemplate")
	f.Scroll:SetFrameLevel(f:GetFrameLevel() - 1)
	f.Scroll.ScrollBar:SetParent(f)
	f.Scroll.ScrollBar:SetScript('OnValueChanged', function(self, value)
		f.Scroll:SetVerticalScroll(value);
	end)
	
	f.editBox = CreateFrame("EditBox", nil, f) 
	f.editBox:SetFontObject(ChatFontWhite)
	f.editBox:SetFrameLevel(f:GetFrameLevel()-1)
	f.editBox:SetAutoFocus(false)
	f.editBox:SetWidth(800)
	f.editBox:SetHeight(300)	
	f.editBox:SetMultiLine(true)
	f.editBox:SetScript("OnEscapePressed", function(self)
		self:ClearFocus()
	end)

	f.Scroll:SetScrollChild(f.editBox)
	f.Scroll:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, -2)
	f.Scroll:SetPoint("TOPLEFT", f, "TOPLEFT", 0, -2)
	f.Scroll:SetPoint("BOTTOM", f, "BOTTOM", 0, 2)
	f.Scroll:SetClipsChildren(true)
	
	f.editBox:SetPoint('TOPLEFT', f.Scroll, "TOPLEFT", 11, 0)
	f.editBox:SetPoint('TOPRIGHT', f.Scroll, "TOPRIGHT", 0, 0)
	f.editBox:SetPoint("BOTTOM", f, "BOTTOM", 0, 2)
	f.editBox:SetHyperlinksEnabled(true)
	f.editBox:SetScript('OnHyperlinkClick', function(self, link, text, button)
		SetItemRef(link, text, button, self);
	end)
	f.editBox:SetFont("Fonts\\ARIALN.TTF", 12)
	
	f.Scroll:SetSize(500, 300)
	f.Scroll:SetHorizontalScroll(-5)
	f.Scroll:SetVerticalScroll(0)
	f.Scroll:EnableMouse(true)
	
	f.editBox:Show()
	f.Scroll:Show()
	f:Show()
	
	copyframe.f = f
end
CreateCoreButton(copyframe)


local whisperList
local list

copyframe:Hide()
copyframe:SetBackdrop(backdrop)
copyframe:SetBackdropColor(0, 0, 0, 0.8)
copyframe:SetBackdropBorderColor(0 , 0 , 0 , 1)

copyframe.close = CreateFrame("Button", nil, copyframe.f.editBox)
copyframe.close:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
copyframe.close:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
copyframe.close:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight", "ADD")
copyframe.close:SetSize(32, 32)
copyframe.close:SetPoint('TOPRIGHT', copyframe, 'TOPRIGHT', 0, 0)
copyframe.close:SetScript("OnClick", function(self) 
	mover:Hide();
	copyframe:Hide();
	copyframe.f.editBox:SetText(""); 
	mover.Owner:SetText(''); 
	copyframe.f.editBox:ClearFocus()
	
	whisperList.expanded = false;
	for i=1, #list do
		list[i]:Hide()
	end
end)

list = {}

local function UpdateHistoryButtons(self)
	self.expanded = not self.expanded
	
	
	self.stat:SetText('>\n>\n>\n>\n>\n>\n>\n>\n>\n>\n>\n>\n>')
	
	for i=1, #list do
		list[i]:Hide()
	end
		
	if self.expanded then
	
		self.stat:SetText('<\n<\n<\n<\n<\n<\n<\n<\n<\n<\n<\n<\n<')
		
		self.id = self.id or {}
		wipe(self.id)
	
		for k,v in pairs(db) do
			self.id[#self.id+1] = { k, v.timestamp }
		end
		
		table.sort(self.id, function(x, y)
			return x[2] > y[2]	
		end)
		
		for i, data in ipairs(self.id) do
			if list[i] then
				list[i].unit = data[1]
				
				if db[data[1]].types == "bnet" then
					local name = strsplit("#", data[1])
					list[i].text:SetText(E.RGBToHex(23, 189, 222)..name.."|r")					
					list[i].icon:SetVertexColor(23/255, 189/255, 222/255, 1)
				elseif db[data[1]].types == 'whisper' and db[data[1]].class and RAID_CLASS_COLORS[db[data[1]].class] then
					local c = RAID_CLASS_COLORS[db[data[1]].class] 
					local name = strsplit("-", data[1])
					list[i].text:SetText('|c'..c.colorStr..name.."|r")	
					list[i].icon:SetVertexColor(220/255, 166/255, 205/255, 1)
				else
					local name = strsplit("-", data[1])
					list[i].text:SetText(E.RGBToHex(220, 166, 205)..name.."|r")
					list[i].icon:SetVertexColor(220/255, 166/255, 205/255, 1)
				end
				
				list[i]:Show()
			end
		end
	end
end

whisperList = CreateFrame("Frame", nil, copyframe)
whisperList:SetFrameLevel(copyframe:GetFrameLevel() + 5)
whisperList:SetSize(20, copy_h)
whisperList:SetPoint("TOPRIGHT", copyframe, "TOPLEFT", -5, 0)
whisperList:SetPoint("BOTTOMRIGHT", copyframe, "BOTTOMLEFT", -5, 0)
whisperList:SetBackdrop(backdrop)
whisperList:SetBackdropColor(0.1,0.1,0.1,0.9) --цвет фона
whisperList:SetBackdropBorderColor(0 , 0 , 0 , 1) --цвет фона
whisperList:SetScript('OnMouseUp', UpdateHistoryButtons)
whisperList:SetScript('OnMouseDown', function(self)end)

whisperList.stat = whisperList:CreateFontString()
whisperList.stat:SetPoint('LEFT', whisperList, 'LEFT')
whisperList.stat:SetFont(E.media.default_font, E.media.default_font_size+4, 'OUTLINE')
whisperList.stat:SetText('>\n>\n>\n>\n>\n>\n>\n>\n>\n>\n>\n>\n>')

local function BuildTextString(unit)
	local text = ""
	local lastData = nil
	
	for i=#db[unit].datas-50, #db[unit].datas, 1 do
		if db[unit].datas[i] then
		
			local data = db[unit].datas[i]:sub(1, 8)
			local ttext = db[unit].datas[i]:sub(9)
			
			if lastData ~= data then
				text = text.."\n"..data.."\n"
				lastData = data
			end
			
			text = text..'  '..ttext.."\n"
		end
	end
	
	return text
end

local function UpdateScroll()
	copyframe.f.Scroll:SetVerticalScroll(copyframe.f.Scroll:GetVerticalScrollRange())
end

local function DeleteLog(self)
	AleaUI_GUI.ShowPopUp(
		   'AleaUI', 
		   "Вы действительно хотите |cffff0000УДАЛИТЬ|r эту историю?.", 
		   { name = "Да", OnClick = function() 
				db[self.unit] = nil
				whisperList.expanded = false
				UpdateHistoryButtons(whisperList)
			end}, 
		   { name = "Нет", OnClick = function() 	   
				
		   end}		   
		)
end

local function ShowLog(self, button)

	if button == 'RightButton' then
		DeleteLog(self)
		return
	end
	
	whisperList.expanded = false
	
	for i=1, #list do
		list[i]:Hide()
	end

	copyframe.f.editBox:SetText(BuildTextString(self.unit))			
	mover.Owner:SetText(self.unit)
	
	if db[self.unit].types == 'bnet' then
		copyframe.f.editBox:SetTextColor(23/255, 189/255, 222/255)
		mover.Owner:SetTextColor(23/255, 189/255, 222/255)
	elseif db[self.unit].types == 'whisper' and db[self.unit].class and RAID_CLASS_COLORS[db[self.unit].class] then
		copyframe.f.editBox:SetTextColor(220/255, 166/255, 205/255)
		local c = RAID_CLASS_COLORS[db[self.unit].class]
		mover.Owner:SetTextColor(c.r, c.g, c.b)
	else
		copyframe.f.editBox:SetTextColor(220/255, 166/255, 205/255)
		mover.Owner:SetTextColor(220/255, 166/255, 205/255)
	end
	
	C_Timer.After(0.2, UpdateScroll)
	
end

local perRow = 4
local numRows = 12
local curNum = 0
local curRow = 1
local buttonW, buttonH = 110, 18

for i=1, perRow*numRows do

	curNum = curNum + 1
	
	if curNum > perRow then
		curNum = 1
		curRow = curRow + 1
	end
	
	list[i] = CreateFrame("BUTTON", nil, whisperList)
	list[i]:SetSize(buttonW, buttonH)
	list[i]:SetBackdrop(backdrop)
	list[i]:SetBackdropColor(0.2 , 0.2 , 0.2 , 0.8) --цвет фона
	list[i]:SetBackdropBorderColor(0.5 , 0.5 , 0.5 , 1) --цвет фона
	list[i]:RegisterForClicks('AnyUp')
	
	if curNum == 1 then
		list[i]:SetPoint("TOPLEFT", copyframe, "TOPLEFT", 8, -4 -( 20 * ( curRow - 1) ))
	else
		list[i]:SetPoint('LEFT', list[i-1], 'RIGHT', 2, 0)
	end
	
	list[i]:SetScript("OnEnter", function(self)
		list[i]:SetBackdropColor(0.5 , 0.5 , 0.2 , 0.8) --цвет фона
	end)
	list[i]:SetScript("OnLeave", function(self)
		list[i]:SetBackdropColor(0.2 , 0.2 , 0.2 , 0.8) --цвет фона
	end)
	
	list[i]:SetScript("OnClick", ShowLog)
	
	
	list[i].icon = list[i]:CreateTexture()
	list[i].icon:SetSize(buttonH, buttonH)
	list[i].icon:SetTexture('Interface\\ChatFrame\\UI-ChatWhisperIcon')
	list[i].icon:SetPoint('LEFT', list[i], 'LEFT', 0, 0)
	
	list[i].text = list[i]:CreateFontString()
	list[i].text:SetFontObject(GameFontWhite)
	list[i].text:SetPoint('LEFT', list[i].icon, 'RIGHT', 0, 0)
	list[i].text:SetPoint('RIGHT', list[i], 'RIGHT', 0, 0)
	list[i].text:SetJustifyH('LEFT')
	
	list[i].text:SetFont(E.media.default_font, E.media.default_font_size)
	list[i]:Hide()
	
end

local bttn = CreateFrame("Button",nil, E.UIParent)
bttn:SetWidth(18)
bttn:SetHeight(18)
bttn:SetScale(1)
bttn:SetAlpha(0.3)
bttn:SetPoint('TOPRIGHT', ChatFrame1, 'TOPRIGHT', 0, -20)

bttn:SetNormalTexture(GetSpellTexture(80353))
bttn:GetNormalTexture():SetTexCoord(unpack(E.media.texCoord))
bttn:GetNormalTexture():SetDesaturated(true)
bttn:SetScript("OnClick", function(self) 
	copyframe:Show() 
	mover:Show()
end)

bttn:SetMovable(true)
bttn:SetUserPlaced(true)
bttn:EnableMouse(true)
bttn:RegisterForDrag("LeftButton","RightButton")
--	bttn:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", insets = {top = -2, left = -2, bottom = -2, right = -2}})
--	bttn:SetBackdropColor(0, 0, 0, 1)
bttn:SetHighlightTexture("Interface\\Tooltips\\UI-Tooltip-Background")
	
	
	
local function realStr(str)
	return gsub(str , "|", "||")
end
	
C:RegisterEvent("CHAT_MSG_BN_WHISPER") -- incoming
C:RegisterEvent("CHAT_MSG_BN_WHISPER_INFORM") -- outgoing
C:RegisterEvent("CHAT_MSG_WHISPER") -- incoming
C:RegisterEvent("CHAT_MSG_WHISPER_INFORM") -- outgoing
-- whisper 220, 166, 205
-- bnet 41, 134, 255

local whispto = " To me: "
local from = " Me: "

local string_match = string.match
function E.Erase(name)
	if not name then return name end
	local rname = string_match(name, "(.+)-") or name
	return rname
end

function C:CHAT_MSG_BN_WHISPER(event, message, sender, ...)
	local senderID = select(11, ...)
	local presenceID, presenceName, battleTag, isBattleTagPresence, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isRIDFriend, broadcastTime, canSoR = BNGetFriendInfoByID(senderID)
	
--	print(event, realStr(sender), senderID, presenceID, realStr(presenceName), realStr(battleTag), isBattleTagPresence, realStr(toonName))
	
	if not db[battleTag] then 
		db[battleTag] = {} 
		db[battleTag].timestamp = 0
		db[battleTag].types = "bnet"
		db[battleTag].datas = {}
	end
	
	db[battleTag].timestamp = time()
	db[battleTag].datas[#db[battleTag].datas+1] = date().." || "..from..message
end

function C:CHAT_MSG_BN_WHISPER_INFORM(event, message, target, ...)

	local senderID = select(11, ...)
	local presenceID, presenceName, battleTag, isBattleTagPresence, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isRIDFriend, broadcastTime, canSoR = BNGetFriendInfoByID(senderID)
	
--	print(event, realStr(target), senderID, presenceID, realStr(presenceName), realStr(battleTag), isBattleTagPresence, realStr(toonName))
	
	if not db[battleTag] then 
		db[battleTag] = {} 
		db[battleTag].timestamp = 0
		db[battleTag].types = "bnet"
		db[battleTag].datas = {}
	end
	db[battleTag].timestamp = time()
	db[battleTag].datas[#db[battleTag].datas+1] = date().." || "..whispto..message
end

function C:CHAT_MSG_WHISPER(event, message, sender, ...)	
	local guid = select(10, ...)
	local class, classFilename, race, raceFilename, sex, name, realm = GetPlayerInfoByGUID(guid or '')
--	print('T', sender)
	
	local sender2 = strsplit('-', sender)
	
	if not db[sender2] then 
		db[sender2] = {} 
		db[sender2].timestamp = 0
		db[sender2].types = "whisper"
		db[sender2].datas = {}
	end
	
	if classFilename then
		db[sender2].class = classFilename
	end
	
	db[sender2].timestamp = time()
	db[sender2].datas[#db[sender2].datas+1] = date().." || "..from..message
end

function C:CHAT_MSG_WHISPER_INFORM(event, message, target, ...)
	local guid = select(10, ...)
	local class, classFilename, race, raceFilename, sex, name, realm = GetPlayerInfoByGUID(guid or '')
	
--	print('T', target)
	
	local target2 = strsplit('-', target)
	
	if not db[target2] then 
		db[target2] = {} 
		db[target2].timestamp = 0
		db[target2].types = "whisper"
		db[target2].datas = {}
	end
	
	if classFilename then
		db[target2].class = classFilename
	end
	db[target2].timestamp = time()
	db[target2].datas[#db[target2].datas+1] = date().." || "..whispto..message
end

local function AddToHistory(target, data)

	if AleaUIDB["WhispersLogs"][target] then
	
		AleaUIDB["WhispersLogs"][target].timestamp = data.timestamp
		
		if data.class then
			AleaUIDB["WhispersLogs"][target].class = data.class
		end
		
		for i=1, #data.datas do
			AleaUIDB["WhispersLogs"][target].datas[#AleaUIDB["WhispersLogs"][target].datas+1] = data.datas[i]
		end
	else	
		AleaUIDB["WhispersLogs"][target] = data
	end
	
end

local function InitChatLogs()
	
	if not AleaUIDB then AleaUIDB = {} end
	if not AleaUIDB["WhispersLogs"] then AleaUIDB["WhispersLogs"] = {} end
	
	for target, data in pairs(db) do	
		AddToHistory(target, data)
	end
	
	db = AleaUIDB["WhispersLogs"]
end
	

E:OnInit(InitChatLogs)