﻿--Blizzard_TalkingHeadUI


local AddOn, E = ...
local Skins = E:Module("Skins")
local _G = _G

local default_background_color = Skins.default_background_color
local default_border_color = Skins.default_border_color
local default_font = Skins.default_font
local default_texture = Skins.default_texture

local default_button_background = Skins.default_button_background
local default_button_border 	= Skins.default_button_border
local default_border_color_dark = Skins.default_border_color_dark

local varName = 'talkingHead'
AleaUI.default_settings.skins[varName] = true

AleaUI:OnAddonLoad('Blizzard_TalkingHeadUI', function()
	if not AleaUI.db.skins.enableAll then return end
	if not AleaUI.db.skins[varName] then return end
	
	TalkingHeadFrame:ClearAllPoints()
	TalkingHeadFrame:SetIgnoreFramePositionManager(true)
	
	E:Mover(TalkingHeadFrame, "TalkingHeadMover")
end)

local function SkinTalkingHead()
	if not AleaUI.db.skins.enableAll then return end
	if not AleaUI.db.skins[varName] then return end
	
	local events = CreateFrame('Frame')
	events:RegisterEvent('PLAYER_REGEN_ENABLED')
	events:RegisterEvent('PLAYER_REGEN_DISABLED')
	events:SetScript('OnEvent', function(self, event)
		if event == 'PLAYER_REGEN_ENABLED' then
			if not TalkingHeadFrame then
				-- UIParent
				UIParent:RegisterEvent("TALKINGHEAD_REQUESTED");
			else
				TalkingHeadFrame:RegisterEvent("TALKINGHEAD_REQUESTED");
			end
		else
			if not TalkingHeadFrame then
				-- UIParent
				UIParent:UnregisterEvent("TALKINGHEAD_REQUESTED");
			else
				if TalkingHeadFrame:IsVisible() then
					TalkingHeadFrame_CloseImmediately()
				end
				TalkingHeadFrame:UnregisterEvent("TALKINGHEAD_REQUESTED");
			end
		end
	end)
end

E:OnInit2(SkinTalkingHead)